// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once
#include "ISCW_UObject.h"

#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{
	class ISCW_ULevelScriptBlueprint;
	class ISCW_ULevel : public virtual ISCW_UObject
	{
	public:
		virtual ~ISCW_ULevel() = default;
		
		virtual shared_ptr<ISCW_ULevel> ToULevelPtr() = 0;
		virtual shared_ptr<const ISCW_ULevel> ToULevelPtr() const = 0;

		virtual shared_ptr<ISCW_ULevelScriptBlueprint> GetLevelScriptBlueprint() const = 0;
	};

	using ISCW_ULevelConstPtr = shared_ptr<const ISCW_ULevel>;
	using ISCW_ULevelPtr = shared_ptr<ISCW_ULevel>;
} // namespace Sourcify